include<ub.scad>//->http://v.gd/ubaer or https://github.com/UBaer21/UB.scad
if(Version<useVersion||is_undef(Version))echo("Install current ub.scad library‼ ⇒ v.gd/ubaer"); 

/*[Hidden]*/
  useVersion=21.362;
  vp=false;
  bed=true;
  $info=true;
  nozzle=.2;

/*[Paw]*/// version 2

h=11;
neg=true;
paw=2;//[0:none,1:cat,2:baer]

if(!neg)Tz(h)Color("gray")T(y=1.25)rotate(90)Paw();

Schnitt(0){
difference(){//cap
    rand=n(3);
    color("Ivory")Prisma(18,18,h,s=1,c1=4,x2=13,y2=15,y2d=1);
    Tz(-.1)Prisma(18-rand*2,18-rand*2,h-1.35,s=1,c1=4-rand*2,x2=13-rand*1.7,y2=15-rand*1.7,y2d=1);
    
    color("Ivory")Tz(h+11.8)T(+0,0.90)scale([1.5,1])R(90)Pille(15.30,d=25,center=true,rad=-.75,fn=100);
  if(neg)  Tz(h+0.7)T(y=1.25)Color("gray")rotate(90)Paw();
}

union(){// MX connector
Tz(1.2)difference(){
    Pille(h-2.6,d=5.5,center=false,rad=.25);
    KeyPin();
}
Tz(h-1.50)R(180)Kehle(dia=5.5);
union(){//Support
    cylinder(1.2-l(2),d=10);
    Grid(es=2.7)Grid(es=0.7)cylinder(1.2-l(1),d=n(2),$fn=8);
    
}
}
}



module Paw(paw=paw){
  if(paw==1)CatPaw();
  if(paw==2)BearPaw();
  }


module BearPaw(s=3.5){
  Tz(-0.4)  T(+0.5)  rotate(-70) Polar(5,s*1.4,end=140,dr=-140,re=-23)scale([0.35,1.0,$idx==2?0.7:0.60])OctaH(n=24,d=[0.7,0.6,1.2]*s);//sphere(d=s,$fn=36);
 Tz(-1.2)  T(-1.9)  rotate(-70) Polar(5,s*1.3,end=140,dr=-140,re=+160)scale([0.9,1.2,$idx==2?0.91:0.75])minkowski(){
  OctaH(n=24,d=[1,0.4,0.3]*s/2);
  OctaH(n=24,d=[0.4,1,0.4]*s/2);
 }
   //sphere(d=s,$fn=36);
  Tz(-0.8) T(-3.7) hull()Polar(3,s/2,end=180,dr=-150,r=-90){
       rotate(-15)scale([1.6,1.5,0.6])sphere(d=s);
       //rotate($idx*+41.3)T(-1.8,-1.2,z=+0.2)sphere(d=s/2.5,$fn=36);
   }
 
}

module CatPaw(s=3){
 
 Tz(-0.4)  T(0.7)  rotate(-110) Polar(4,s*1.2,end=220,dr=355,re=+5)scale([1,1.2,.8])sphere(d=s,$fn=36);
  Tz(-0.8) T(-3.7) Polar(3,s/2,end=180,dr=-150,r=-90)hull(){
       rotate(-15)scale([1,1.3,.8])sphere(d=s);
       rotate($idx*+41.3)T(-1.8,-1.2,z=+0.2)sphere(d=s/2.5,$fn=36);
   }
 
}


module KeyPin(){
linear_extrude(5,scale=0.98)Rund(.1,.3)offset(.2){
    square([.8,4],true);
    square([4,1],true);
}

linear_extrude(1,scale=0)offset(.15)Rund(.1,.3)offset(.2){
    square([.8,4],true);
    square([4,1],true);
}
Tz(5)linear_extrude(2,scale=0.2)scale(0.98)Rund(.1,.3)offset(.2){
    square([.8,4],true);
    square([4,1],true);
}
}